﻿using BPA.Helper;
using DTO;
using HKCardOUT.Helper;
using HKCardOUT.Logic.Service;
using Stylet;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading;
using System.Windows.Media;
using HKControl;
using System.Collections.Concurrent;
using System.Text;
using ImTools;

namespace HKCardOUT.ViewModels
{
    public class AdWindowViewModel : NotifyBase
    {

        public AdWindowViewModel()
        {
            for (int i = 0; i < 6; i++)
            {
                Foods.Add("");
            }
        }

        #region 属性

        public AdInfoModel LAdInfo { get { return _mLAdInfo; } set { _mLAdInfo = value; OnPropertyChanged(); } }
        private AdInfoModel _mLAdInfo = new AdInfoModel();

        public AdInfoModel RAdinfo { get { return _mRAdinfo; } set { _mRAdinfo = value; OnPropertyChanged(); } }
        private AdInfoModel _mRAdinfo = new AdInfoModel();

        public ObservableCollection<string> Foods { get; set; } = new ObservableCollection<string>();


        #endregion

        void FoodsInit()
        {
            string GateId = string.Empty;
            GateId = DataBus.StoreInfo.Devices.Select(t => t.GateId).FirstOrDefault();
            var res = DataBus.Menu.GateFood.Where(t => t.GateId == GateId)?.Select(t => t.Foods)?.FirstOrDefault();
            if (res != null)
            {
                App.Current.Dispatcher.Invoke(() =>
                {
                    for (int i = 0; i < Foods.Count; i++)
                    {
                        if (i >= 0 && i < res.Count)
                            Foods[i] = res.ElementAt(i);
                    }
                });
            }
        }

        public void InitData()
        {
            FoodsInit();

            ThreadManage.GetInstance().StartLong(() =>
            {
                var model = (new HKCore()).PullDaySaleLog();

                LAdInfo.Gate = $"4，5，6号档口";
                RAdinfo.Gate = $"1，2，3号档口";
                LAdInfo.Count = model.Where(t => t.Key == "4" || t.Key == "5" || t.Key == "6").Sum(t => t.Value);
                RAdinfo.Count = model.Where(t => t.Key == "1" || t.Key == "2" || t.Key == "3").Sum(t => t.Value);
                StringBuilder sb1 = new StringBuilder();
                sb1.Append((!Main.GetInstance.GetIsConnect(4) ? "4号未连接" : (Main.GetInstance.GetIsSwipe(4) ? "4号正常" : "4号异常")+"\r"));
                sb1.Append((!Main.GetInstance.GetIsConnect(5) ? "5号未连接" : (Main.GetInstance.GetIsSwipe(5) ? "5号正常" : "5号异常")+"\r"));
                sb1.Append((!Main.GetInstance.GetIsConnect(6) ? "6号未连接" : (Main.GetInstance.GetIsSwipe(6) ? "6号正常" : "6号异常")+"\r"));
                LAdInfo.Msg = sb1.ToString();
                StringBuilder sb2 = new StringBuilder();
                sb2.Append((!Main.GetInstance.GetIsConnect(1) ? "1号未连接" : (Main.GetInstance.GetIsSwipe(1) ? "1号正常" : "1号异常")+"\r"));
                sb2.Append((!Main.GetInstance.GetIsConnect(2) ? "2号未连接" : (Main.GetInstance.GetIsSwipe(2) ? "2号正常" : "2号异常")+"\r"));
                sb2.Append((!Main.GetInstance.GetIsConnect(3) ? "3号未连接" : (Main.GetInstance.GetIsSwipe(3) ? "3号正常" : "3号异常")+"\r"));
                RAdinfo.Msg = sb2.ToString();

                if (DataBus.saleLogDtos.Count > 0)
                {
                    DataBus.saleLogDtos.TryDequeue(out SaleLogDto info);
                    ScreenInfoDto data = new ScreenInfoDto
                    {
                        CardNo = info.CardNo,
                        UserName = "",
                        Location = info.Location,
                    };
                    data.UserName = DataBus.UserListDto
                        .Where(t => t.Cards.Select(x => x.CardNum).Contains(data.CardNo))
                        .Select(x => x.Name).FirstOrDefault();

                    App.Current.Dispatcher.Invoke(() =>
                    {
                        if (LAdInfo.Info != null && !string.IsNullOrEmpty(LAdInfo.Info.UserName))
                        {
                            LAdInfo.AInfo.Insert(0, LAdInfo.Info);
                            LAdInfo.Info.Time = DateTime.Now.ToString("HH:mm:ss");
                        }
                        if (RAdinfo.Info != null && !string.IsNullOrEmpty(RAdinfo.Info.UserName))
                        {
                            RAdinfo.AInfo.Insert(0, RAdinfo.Info);
                            RAdinfo.Info.Time = DateTime.Now.ToString("HH:mm:ss");
                        }
                    });
                    LAdInfo.Info = data.Location == "4" || data.Location == "5" || data.Location == "6" ? data : new ScreenInfoDto();
                    RAdinfo.Info = data.Location == "1" || data.Location == "2" || data.Location == "3" ? data : new ScreenInfoDto();
                }
                Thread.Sleep(10);
            }, $"屏幕刷卡信息", true);
        }
    }
}
